package rocks.zipcode.io.quiz4.generics;

import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author leon on 18/12/2018.
 */
public class Group<T> implements GroupInterface<T> {

    private ArrayList<T> list = new ArrayList<>();

    public Group() {
    }

    public Integer count() {
        return list.size();
    }



    public void insert(T value) {
        list.add(value);
    }

    public Boolean has(T value) {
        return list.contains(value);
    }

    public T fetch(int indexOfValue) {
        return list.get(indexOfValue);
    }


    public void delete(T value) {
        list.remove(value);
    }

    public void clear() {
        list.clear();
    }

    public Iterator<T> iterator() {
        return list.iterator();
    }

    @Override
    public String toString(){
        String str = "";
        for (T item: list) {
            if(str.equals("")) {
                str+= item.toString();
            } else {
                str+= ", ";
                str+= item.toString();
            }
        }
        return "[" + str + "]";
    }

    public void setList(ArrayList<T> list) {
        this.list = list;
    }

    public ArrayList<T> getList() {
        return list;
    }
}
